using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PropertyBindingSample {
  public partial class MainForm : Form {

    public MainForm() {
      InitializeComponent();

      this.Location = Properties.Settings.Default.MainFormLocation;
      this.Size = Properties.Settings.Default.MainFormSize;
      this.WindowState = Properties.Settings.Default.MainFormWindowState;
    }

    private void MainForm_FormClosing(object sender, FormClosingEventArgs e) {
      
      if( this.WindowState == FormWindowState.Normal ) {
        Properties.Settings.Default.MainFormLocation = this.Location;
        Properties.Settings.Default.MainFormSize = this.Size;
      }
      else {
        Properties.Settings.Default.MainFormLocation = this.RestoreBounds.Location;
        Properties.Settings.Default.MainFormSize = this.RestoreBounds.Size;
      }
      Properties.Settings.Default.MainFormWindowState = this.WindowState;
      
      Properties.Settings.Default.Save();
    }

    private void setBackColorButton_Click(object sender, EventArgs e) {
      this.colorDialog.Color = this.BackColor;
      if( this.colorDialog.ShowDialog() == DialogResult.OK ){
        this.BackColor = this.colorDialog.Color;
      }
    }
  }
}