﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;

namespace SettingsVersioningSample {
  partial class MainForm : Form {
    public MainForm() {
      InitializeComponent();
    }

    private void MainForm_Load(object sender, EventArgs e) {
      this.userSettingTextBox.Text = Properties.Settings.Default.userSettingv1;
      this.versionToolStripStatusLabel.Text = "Assembly File Version: " + this.AssemblyFileVersion;
    }

    private void saveToolStripMenuItem_Click(object sender, EventArgs e) {
      Properties.Settings.Default.Save();
    }
    
    private void exitToolStripMenuItem_Click(object sender, EventArgs e) {
      Close();
    }

    private void saveRollbackToolStripMenuItem_Click(object sender, EventArgs e) {
      Properties.Settings.Default.Reload();
      this.userSettingTextBox.Text = Properties.Settings.Default.userSettingv1;
    }
    
    private void installRollbackToolStripMenuItem_Click(object sender, EventArgs e) {
      Properties.Settings.Default.Reset();
      this.userSettingTextBox.Text = Properties.Settings.Default.userSettingv1;
    }

    private void saveButton_Click(object sender, EventArgs e) {
      Properties.Settings.Default.userSettingv1 = this.userSettingTextBox.Text;
    }

    public string AssemblyFileVersion {
      get {
        // Get all Product attributes on this assembly
        object[] attributes = Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyFileVersionAttribute), false);
        // If there aren't any Product attributes, return an empty string
        if( attributes.Length == 0 )
          return "";
        // If there is a Product attribute, return its value
        return ((AssemblyFileVersionAttribute)attributes[0]).Version;
      }
    }
  }
}