﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace WebServiceCalcPiSample {

  partial class AsyncCalcPiForm : Form {

    bool isBusy = false;
    bool cancellationPending = false;

    ////CalcPiWebService.CalcPiService service = new CalcPiWebService.CalcPiService();

    public AsyncCalcPiForm() {
      InitializeComponent();
    }

    private void calcButton_Click(object sender, EventArgs e) {
      //// Calculate pi synchronously
      //this.resultsTextBox.Text = service.CalcPi((int)this.decimalPlacesNumericUpDown.Value);

      // Don't process if cancel request pending
      if( this.cancellationPending ) return;

      // Is web service currently executing
      if( isBusy ) {
        // Cancel asynchronous pi calculations
        this.calcPiServiceComponent.CancelAsync(null);
        this.cancellationPending = true;
      }
      else {
        // Start calculating pi asynchronously
        this.calcButton.Text = "Cancel";
        this.resultsTextBox.Text = "";
        this.isBusy = true;
        this.calcPiServiceComponent.CalcPiAsync((int)this.decimalPlacesNumericUpDown.Value);
      }      // Don't process if cancel request pending
      
      
      ////if( this.cancellationPending ) return;

      ////// Is web service currently executing
      ////if( isBusy ) {
      ////  // Cancel asynchronous pi calculations
      ////  this.service.CancelAsync(null);
      ////  this.cancellationPending = true;
      ////}
      ////else {
      ////  // Start calculating pi asynchronously
      ////  this.calcButton.Text = "Cancel";
      ////  this.resultsTextBox.Text = "";
      ////  this.service.CalcPiCompleted += service_CalcPiCompleted;
      ////  this.isBusy = true;
      ////  this.service.CalcPiAsync((int)this.decimalPlacesNumericUpDown.Value);
      ////}
    }

    private void service_CalcPiCompleted(object sender, WebServiceCalcPiSample.CalcPiWebService.CalcPiCompletedEventArgs e) {

      // Reset UI state
      this.calcButton.Text = "Calculate";

      // We're not busy anymore
      this.isBusy = false;

      // Was there an error?
      if( e.Error != null ) {
        this.resultsTextBox.Text = e.Error.Message;
        return;
      }

      // Was the worker thread cancelled?
      if( e.Cancelled ) {
        this.resultsTextBox.Text = "Cancelled";
        // Allow calculations to start
        this.cancellationPending = false;
      }

      // Display result
      this.resultsTextBox.Text = e.Result;
    }

    private void calcPiServiceComponent_CalcPiCompleted(object sender, WebServiceCalcPiSample.CalcPiWebService.CalcPiCompletedEventArgs e) {

      Debug.Assert(this.InvokeRequired == false);
      if( this.InvokeRequired == true ) throw new Exception("Doh!");

      // Reset UI state
      this.calcButton.Text = "Calculate";

      // We're not busy anymore
      this.isBusy = false;

      // Was there an error?
      if( e.Error != null ) {
        this.resultsTextBox.Text = e.Error.Message;
        return;
      }

      // Was the worker thread cancelled?
      if( e.Cancelled ) {
        this.resultsTextBox.Text = "Cancelled";
        // Allow calculations to start
        this.cancellationPending = false;
      }

      // Display result
      this.resultsTextBox.Text = e.Result;
    }
  }
}